AWSTemplateFormatVersion: "2010-09-09"

Description:  This template deploys an internet gateway and public route tables for a VPC.

#MetaData

Parameters: 
  VPCName:
    Type: String
    Description: The name of the VPC.
    Default: project3-vpc-stack 

  VpcID: 
    Type: String 
    Default: ''
    Description: Network stack    

  PublicSubnet1:
    Type: String
    Description: The public subnet located in Availability Zone 1.

  PublicSubnet2:
    Type: String
    Description: The public subnet located in Availability Zone 2.


Resources:
  InternetGateway:
    Type: AWS::EC2::InternetGateway
    Properties:
      Tags:
        - Key: Name
          Value: StackIGW

  InternetGatewayAttachment:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      InternetGatewayId: !Ref InternetGateway
      VpcId: !Ref VpcID 

  PublicRouteTable:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref VpcID
      Tags:
        - Key: Name
          Value: !Sub ${VPCName} Public Routes

  DefaultPublicRoute:
    Type: AWS::EC2::Route
    DependsOn: InternetGatewayAttachment
    Properties:
      RouteTableId: !Ref PublicRouteTable
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway

  PublicSubnet1RouteTableAssociation:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnet1

  PublicSubnet2RouteTableAssociation:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnet2
      

Outputs:
  InternetGateway:
    Description: IgwID
    Value: !Ref InternetGateway
    Export: 
      Name: IgwID